#!/usr/bin/perl -w
# $Id: logdistrib.pl,v 1.2 2001/01/18 16:58:08 serces Exp $
# $Author: serces $
# $Revision: 1.2 $

use strict;

my $Debug = 0;
my $smpath = "/usr/sbin/sendmail";
my $Infile;
my %Config;
my %Output;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
my $MailDate = sprintf("%04d%02d%02d-%02d%02d", $year+1900,$mon+1,$mday,$hour,$min);
$Infile = "PATH/TO/SYSLOG" unless ($Infile = $ARGV[0]);

die $! unless (open(INFILE,"<$Infile"));

die $! unless (open(CONF,"< PATH/TO/logdistrib.conf"));
print "Reading Config\n" if ($Debug);
while (<CONF>) {
  chomp;
  unless (/^#/ or /^;/ or !/=/) {
    my ($Field,$RegExp) = split(/=/,$_,2);
    $Config{$Field} = $RegExp;
    print " - $Field=>$RegExp\n" if ($Debug);
  }
}
# A bit of sanity
die "No regular Expressions, Stopping\n" unless (grep { /^REG/ } keys %Config);
die "I need at least MAIL-GENERIC to work!!\n" unless ($Config{'MAIL-GENERIC'});
die "Erhm, are you completely sure you don't need a SUB-GENERIC?\n" unless ($Config{'SUB-GENERIC'});

print "Finished Reading Config\n" if ($Debug);
print "Reading $Infile\n" if ($Debug);
my @File = <INFILE>; # Memory operations are faster, even though it may require more Mem, maybe we should take this with Ulrik..
print "Finished Reading $Infile\n" if ($Debug);
print "Starting tests\n" if ($Debug);
foreach my $key (keys %Config) {
  next unless ($key =~ /^REG/);
  print " - Testing for: $key => $Config{$key}\n" if ($Debug);
  @{$Output{$key}} = grep { /$Config{$key}/ } @File;
}
print "Finished tests\n" if ($Debug);

# Code to Ship the Array to a specific user!
my ($Rcpt, $Subject);
print "Starting Mailer\n" if ($Debug);
foreach my $key (keys %Output) {
  next unless (@{$Output{$key}}); # No Need to go anywhere if there isn't anything in the Array
  my ($junk,$Field) = split("-",$key,2);
  print " - Testing MAIL-$Field " if ($Debug);
  next unless ($Config{"MAIL-".$Field} or $Config{"MAIL-GENERIC"}); # Somehow, no mailto, and no generic, no mail!
  next unless ($Config{"SUB-".$Field} or $Config{"SUB-GENERIC"});   # Somehow, no subject, and no generic, no mail!
  print "   - Found either Generic or MAIL-$Field\n" if ($Debug);
  if ($Config{"MAIL-".$Field}) { 
    $Rcpt = $Config{"MAIL-".$Field};
  } else {
    $Rcpt = $Config{"MAIL-GENERIC"};
  }

  if ($Config{"SUB-".$Field}) { 
    $Subject = $Config{"SUB-".$Field};
  } else {
    $Subject = $Config{"SUB-GENERIC"};
  }
#
# Sendmailcode goes here!
#

  if ($Debug) {
    print "From some\@address\n";
    print "From: LogDistributor <some\@address>\n";
    print "To: \"Undisclosed Recipients\"\n";
    print "Mime-Version: 1.0\n";
    print "Reply-to: <some\@address>\n";
    print "X-Reply-to: <some\@address>\n";
    print "X-Mailer: LogDistributor V1.2\n";
    print "Subject: From Reboot $MailDate: $Subject\n\n";
    print @{$Output{"REG-".$Field}};
  } else {
    my $Sendmail = "|" .$smpath." ". $Rcpt;
    open(SENDMAIL,$Sendmail) or die "Can't open sendmail: $!\n";
    print SENDMAIL "From some\@address\n";
    print SENDMAIL "From: LogDistributor <some\@address>\n";
    print SENDMAIL "To: \"Undisclosed Recipients\"\n";
    print SENDMAIL "Mime-Version: 1.0\n";
    print SENDMAIL "Reply-to: <some\@address>\n";
    print SENDMAIL "X-Reply-to: <some\@address>\n";
    print SENDMAIL "X-Mailer: LogDistributor V1.2\n";
    print SENDMAIL "Subject: From Reboot $MailDate: $Subject\n\n";
    print SENDMAIL @{$Output{"REG-".$Field}};
    print SENDMAIL ".\n";
    close SENDMAIL;
  }
}
print "Finished Mailer\n" if ($Debug);
